unit uTEST1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button4: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;
  hDLL:THandle;

implementation

{$R *.DFM}
var
  SetGRData:function(V1,V2:integer):integer;stdcall;
  GetGRData:function(Value:integer):integer;stdcall;

procedure TForm1.FormCreate(Sender: TObject);
begin
	button2.enabled := false;
  button3.enabled := false;
  button4.enabled := false;
  RadioButton1.Checked := true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if hDLL <> 0 then FreeLibrary(hDLL);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  DLLPath: string;
begin
  if RadioButton1.Checked then
  	DLLPath := ExtractFilePath(Application.exename)+'DLL1.DLL'
  else
  	DLLPath := ExtractFilePath(Application.exename)+'DLL2.DLL';
  hDLL := LoadLibrary(PChar(DLLPath));
  if hDLL < 32 then
    raise Exception.Create('Cannot open DLL');

  @SetGRData := GetProcAddress(hDLL, 'SetGRData');
  @GetGRData := GetProcAddress(hDLL, 'GetGRData');
  if (@SetGRData = nil) or (@GetGRData = nil) then
    raise Exception.Create
         ('Can''t Get function address in DLL');

  button1.enabled := false;
  button2.enabled := true;
  button3.enabled := true;
  button4.enabled := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
var RS:integer;
begin
	RS := SetGRData(StrToInt(Edit1.text),StrToInt(Edit2.Text));
  if RS < 0 then
  	ShowMessage('f[^ZbgɎs')
  else
  	Label1.Caption := 'MMF Handle : '+ IntToStr(RS);
end;

procedure TForm1.Button3Click(Sender: TObject);
var i:integer;
begin
	for i := 1 to 2 do
  	Memo1.Lines.add(IntToStr(GetGRData(i)));
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
	FreeLibrary(hDLL);
  Button1.Enabled := true;
  Button2.Enabled := false;
  Button3.Enabled := false;
  Button4.Enabled := false;
end;

end.
